<!DOCTYPE html>
<html lang="en">
{% load static %}

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>app</title>
    <link rel="manifest" href="{% static 'manifest.webmanifest' %}">
    <link href="https://fonts.googleapis.com/css2?family=Ubuntu:wght@500&display=swap" rel="stylesheet">
    <link rel="stylesheet" href="{% static 'css/swiper.min.css' %}">
    <link rel="stylesheet" href="{% static 'css/style.css' %}">
</head>

<body>
    <header class="main-nav">
        <ul>
            <li>
                <a href="/">
                    صفحه اصلی
                </a>
            </li>
            <li>
                <a href="/filtered">
                    صفحه اختصاصی
                </a>
            </li>
        </ul>
        <img src="{% static 'images/logo.png' %}" alt="">

    </header>
    <div class="wrapper">
        <div class="filter-wrapper">
            <h4 class="notic-title">تنظیمات نوتیفیکیشن</h4>
            <div>
                <label for="percentavg">درصد سود</label>
                <input type="number" value=0 name="percentavg">

            </div>
            <div>
                <label for="time"> بازه زمانی به دقیقه</label>
                <input type="number" value=1 name="time" max=60 min=1>

            </div>
            <button class="filter">شروع</button>
            <button class="clearFilter" style="display:none;">پایان</button>

        </div>

        <div class="swiper-container">
            <!-- Add Pagination -->
            <div class="swiper-pagination">
            </div>
            <div class="swiper-wrapper">
                <div class="swiper-slide btc">
                    <table>
                        <thead>
                            <tr>
                                <th>rank</th>
                                <th>Pair</th>
                                <th>last price</th>
                                <th>24hr change</th>
                            </tr>
                        </thead>
                        <tbody>
                        </tbody>
                    </table>

                </div>
                <div class="swiper-slide usdt">
                    <table>
                        <thead>
                            <tr>
                                <th>rank</th>
                                <th>Pair</th>
                                <th>last price</th>
                                <th>24hr change</th>
                            </tr>
                        </thead>
                        <tbody>
                        </tbody>
                    </table>
                </div>
          
            </div>
        </div>

    </div>
    <div class="container"></div>
    <script src="{% static 'js/jquery-1.12.4.min.js' %}"></script>
    <script src="{% static 'js/push.min.js' %}"></script>
    <script src="{% static 'js/swiper.min.js' %}"></script>
    <script>
        var swiper = new Swiper('.swiper-container', {
            pagination: '.swiper-pagination',
            slidesPerView: 1,
            paginationClickable: true,
            loop: true,
            paginationBulletRender: function (index, className) {
                var tabsName = ['BTC', 'USDT'];
                if (index === (tabsName.length - 1)) {
                    return '<span class="' + className + '">'
                        + tabsName[index] + '</span>'
                        + '<div class="active-mark "></div>';
                }
                return '<span class="' + className + '">' + tabsName[index] + '</span>';
            }
        });


        $(".click").click(function () {
            Push.create("Hello world!", {
                body: "How's it hangin'?",
                icon: '/icon.png',
                timeout: 4000,
                onClick: function () {
                    window.focus();
                    this.close();
                }
            });
        })
        function findWithAttr(array, attr, value) {
            for (var i = 0; i < array.length; i += 1) {
                if (array[i][attr] === value) {
                    return i;
                }
            }
            return -1;
        }
        $.ajaxSetup({
            timeout: 3000,
            retryAfter: 2000
        });
        var reached = [];
        var callAjax = function () {
            $.ajax({
                type: 'GET',
                url: 'https://api.binance.com/api/v3/ticker/24hr',
                dataType: 'json',
                success: function (data) {
                    if (localStorage.getItem('time') != null) {
                        $('.clearFilter').show()
                        $('.filter').hide()
                        var startArray = data.filter(function (el) {
                            return el.symbol.indexOf('BTC') != -1 || el.symbol.indexOf('USDT')
                        })
                        var time = parseInt(JSON.parse(localStorage.getItem('time')))
                        var percentavg = JSON.parse(localStorage.getItem('percentavg'))
                        $('input[name="time"]').val(time);
                        $('input[name="percentavg"]').val(percentavg);
                        var count = time * 20
                        var notif = ""
                        $.each(startArray, function (i, d) {
                            var name = d.symbol;
                            if (localStorage.getItem(name) != null) {
                                var array = JSON.parse(localStorage.getItem(name));
                                array.push(d.priceChangePercent)
                            } else {
                                var array = [d.priceChangePercent]
                            }
                            if (array.length >= count) {
                                var sum = 0;
                                $.each(array, function (index, data) {
                                    sum += parseFloat(data);
                                })
                                // console.log(sum)
                                var average = sum / array.length;
                                var remain = average - parseFloat(array[0])
                                var index = reached.indexOf(d.symbol)
                                if (remain > percentavg) {
                                    var str = Math.round(remain * 100) / 100;
                                    if (index == -1) {
                                        notif += d.symbol + " " + str + "%   "
                                        reached.push(d.symbol)
                                    }
                                    // console.log(remain)
                                } else {
                                    if (index != -1) {
                                        reached.splice(index, 1)
                                    }
                                }
                            }
                            if (array.length > count) {
                                array.shift()
                            }
                            localStorage.setItem(name, JSON.stringify(array))
                        })
                        // console.log(reached)
                        if (notif.length > 0) {
                            console.log(notif.length)
                            Push.create("بازه زمانی" + time + " دقیقه", {
                                body: notif,
                                // timeout: 2000,
                                onClick: function () {
                                    window.focus();
                                    this.close();
                                }
                            });
                        }


                    }


                    var startArrayBTC = data.filter(function (el) {
                        return el.symbol.indexOf('BTC') != -1
                    })
                    var startArrayUSDT = data.filter(function (el) {
                        return el.symbol.indexOf('USDT') != -1
                    })
                    var sortDataBTC = data.filter(function (el) {
                        return el.symbol.indexOf('BTC') != -1
                    })
                    var sortDataUSDT = data.filter(function (el) {
                        return el.symbol.indexOf('USDT') != -1
                    })
                    startArrayBTC.sort(function (a, b) {
                        return b.openPrice - a.openPrice;
                    });

                    sortDataBTC.sort(function (a, b) {
                        return b.priceChangePercent - a.priceChangePercent;
                    });
                    startArrayUSDT.sort(function (a, b) {
                        return b.openPrice - a.openPrice;
                    });

                    sortDataUSDT.sort(function (a, b) {
                        return b.priceChangePercent - a.priceChangePercent;
                    });
                    $('.wrapper .btc tbody').html('')
                    $('.wrapper .usdt tbody').html('')
                    $.each(sortDataBTC, function (i, d) {
                        // rankChange = findWithAttr(startArray, 'symbol', d.symbol) - i

                        var color = d.priceChange <= 0 ? "red" : "green"
                        var row_color = ""
                        var rank_sign = ""
                        if (d.priceChangePercent > 0 && d.priceChangePercent < 3) {
                            row_color = "yellow"
                        } else if (d.priceChangePercent > 2 && d.priceChangePercent < 6) {
                            row_color = "lightgreen"
                        } else if (d.priceChangePercent > 5 && d.priceChangePercent < 9) {
                            row_color = "darkgreen"
                        } else if (d.priceChangePercent > 8 && d.priceChangePercent < 12) {
                            row_color = "purple"
                        } else if (d.priceChangePercent > 11 && d.priceChangePercent < 15) {
                            row_color = "darkpurple"
                        } else if (d.priceChangePercent > 14 && d.priceChangePercent < 18) {
                            row_color = "brown"
                        } else if (d.priceChangePercent > 17) {
                            row_color = "black"
                        }
                        var symbol = ""
                        var splitted = d.symbol.split('BTC'); //this will output ["1234", "56789"]
                        var first = splitted[0]; //"1234"
                        var second = splitted[1]; //"56789"
                        if (first != "") {
                            symbol = "<span>" + first + "</span> / <span>BTC</span>"
                        } else if (second != "") {
                            symbol = "</span> <span>BTC</span> / <span>" + second + "</span>"
                        }

                        $('.wrapper .btc tbody').append('<tr class=' + row_color + '><td>' + (i + 1) + '</td><td class="symbol">' + rank_sign + ' ' + symbol + '</td><td>' + (Math.round(d.lastPrice * 10000000) / 10000000).toString() + '</td><td class="td-flex"><span class=' + color + '>' + Math.round(d.priceChangePercent * 10000000) / 10000000 + '%' + '</span></td></tr>')
                    })
                    $.each(sortDataUSDT, function (i, d) {
                        // rankChange = findWithAttr(startArray, 'symbol', d.symbol) - i

                        var color = d.priceChange <= 0 ? "red" : "green"
                        var row_color = ""
                        var rank_sign = ""
                        if (d.priceChangePercent > 0 && d.priceChangePercent < 3) {
                            row_color = "yellow"
                        } else if (d.priceChangePercent > 2 && d.priceChangePercent < 6) {
                            row_color = "lightgreen"
                        } else if (d.priceChangePercent > 5 && d.priceChangePercent < 9) {
                            row_color = "darkgreen"
                        } else if (d.priceChangePercent > 8 && d.priceChangePercent < 12) {
                            row_color = "purple"
                        } else if (d.priceChangePercent > 11 && d.priceChangePercent < 15) {
                            row_color = "darkpurple"
                        } else if (d.priceChangePercent > 14 && d.priceChangePercent < 18) {
                            row_color = "brown"
                        } else if (d.priceChangePercent > 17) {
                            row_color = "black"
                        }
                        var symbol = ""
                        var splitted = d.symbol.split('USDT'); //this will output ["1234", "56789"]
                        var first = splitted[0]; //"1234"
                        var second = splitted[1]; //"56789"
                        if (first != "") {
                            symbol = "<span>" + first + "</span> / <span>USDT</span>"
                        } else if (second != "") {
                            symbol = "</span> <span>USDT</span> / <span>" + second + "</span>"
                        }

                        $('.wrapper .usdt tbody').append('<tr class=' + row_color + '><td>' + (i + 1) + '</td><td class="symbol">' + rank_sign + ' ' + symbol + '</td><td>' + (Math.round(d.lastPrice * 10000000) / 10000000).toString() + '</td><td class="td-flex"><span class=' + color + '>' + Math.round(d.priceChangePercent * 10000000) / 10000000 + '%' + '</span></td></tr>')
                    })
                },
                error: function () {
                    console.log('Ajax request failed...');
                    setTimeout(function () { callAjax() }, $.ajaxSetup().retryAfter);
                }
            })
        }
        callAjax();
        var interval = setInterval(function () {
            callAjax();
        }, 3000);

        $('.filter').click(function () {
            percentavg = $('input[name="percentavg"]').val()
            time = $('input[name="time"]').val()
            localStorage.setItem('percentavg', JSON.stringify(percentavg))
            localStorage.setItem('time', JSON.stringify(time))
            $('.filter-wrapper button.filter').hide();
            $('.filter-wrapper button.clearFilter').show();
        })
        if (localStorage.getItem('percent') != null) {
            percent = JSON.parse(localStorage.getItem('percent'))
            pricefilter = JSON.parse(localStorage.getItem('pricefilter'))
            $('input[name="percentavg"]').val(percentavg)
            $('input[name="time"]').val(time)
        }
        $('.clearFilter').click(function () {
            $(".wrapper tbody").html("")
            localStorage.clear()
            $('.filter-wrapper button.filter').show();
            $('.filter-wrapper button.clearFilter').hide();
        })
    </script>
</body>

</html>